<template>
  <v-app>
    <main>
      <v-container fluid fill-height class="loginOverlay">
        <v-layout flex align-center justify-center>
          <v-flex xs12 sm4 elevation-6>
            <v-toolbar class="pt-5 blue darken-4">
              <v-toolbar-title class="white--text"><h4>Авторизация</h4></v-toolbar-title>
              <v-toolbar-items/>
            </v-toolbar>
            <v-card>
              <v-card-text class="pt-4">
                <div>
                  <v-form v-model="valid" ref="form">
                    <v-text-field
                      label="Почтовый адрес"
                      v-model="email"
                      :rules="emailRules"
                      required
                    ></v-text-field>
                    <v-text-field
                      label="Пароль"
                      v-model="password"
                      :append-icon="e1 ? 'visibility' : 'visibility_off'"
                      :append-icon-cb="() => (e1 = !e1)"
                      :type="e1 ? 'password' : 'text'"
                      :rules="passwordRules"
                      counter
                      required
                    ></v-text-field>
                    <v-layout justify-space-between>
                      <v-btn @click="submit"
                             :class=" { 'blue darken-4 white--text' : valid, disabled: !valid }">Войти
                      </v-btn>
                      <router-link to="/register">Создать аккаунт</router-link>
                    </v-layout>
                  </v-form>
                </div>
              </v-card-text>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </main>
  </v-app>
</template>


<script>
  export default {
    data() {
      return {
        valid: false,
        e1: true,
        password: '',
        passwordRules: [
          (v) => !!v || 'Введите пароль!',
        ],
        email: 'admin@example.com',
        emailRules: [
          (v) => !!v || 'Введите почту!',
          (v) => /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'Не валидная почта'
        ],
      }
    },
    methods: {
      submit() {
        if (this.$refs.form.validate()) {
          let email = this.email
          let password = this.password
          this.$store.dispatch('postLogin', {email, password})
            .then(() => window.location = "/dashboard")
            .catch(e => {
              console.log(e)
            })
        }
      },
      clear() {
        this.$refs.form.reset()
      }
    },
  }
</script>


<style lang="scss" scoped>
  #app {
    background-image: url("https://images.unsplash.com/photo-1497733942558-e74c87ef89db?dpr=1&auto=compress,format&fit=crop&w=1650&h=&q=80&cs=tinysrgb&crop=");
    background-size: cover;
    overflow: hidden;
  }

</style>
